unit xocCButton;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,menus;


type

  TBBStyle = (bsDefault, bsLowered, bsRaised);
  TStyleDEF = (sdFLAT, sdFRAMED, sdRAISED);

  TxocCButton = class(TBevel)
  private

    FPicACTIVE: TPicture;
    FPicDISABLED: TPicture;
    FTikSTEP : Integer;
    FBStyle : TBBStyle;
    FStyleDEFAULT : TStyleDEF;
    FSpacer :integer;
    MLeave : TNotifyEvent;
    MEnter : TNotifyEvent;
    F_LITE : TColor;
    F_DARK : TColor;
    _F_DropDOWN_MENU : TPopUpMenu;

    FGroup : Integer;

    _F_MouseIsDOWN : Boolean;
    _F_MouseIsENTER : Boolean;

    F_TheOwner:TComponent;

    //procedure _SetFrameStyle(val:TBBStyle);
    procedure _SetDefaultStyle(val:TStyleDEF);

    procedure SetActivePic(Value: TPicture);
    procedure SetDisabledPic(Value: TPicture);

    procedure SetSpacer(Value: Integer);
    procedure SetDOWN_MENU(val:TPopUpMenu);

    procedure _SetLiteColor(val:TColor);
    procedure _SetDarkColor(val:TColor);

    procedure _SetGroup(val:Integer);

    procedure CMTextChanged(var Message: TMessage); message CM_TEXTCHANGED;
    procedure CMFontChanged(var Message: TMessage); message CM_FONTCHANGED;

  protected
   procedure MouseLeave(var Message: TMessage); message CM_MOUSELEAVE;
   procedure MouseEnter(var Message: TMessage); message CM_MOUSEENTER;
   procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
   procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
   procedure Paint; override;

  public

    _F_BtnSELECTED  : Boolean;
    procedure _SetFrameStyle(val:TBBStyle);
    procedure SetAsSELECTED;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    
  published

    property Caption;
    property Font;
    property ParentFont;
    property Enabled;

    property StyleDEFAULT : TStyleDEF read FStyleDEFAULT write _SetDefaultStyle;
    property ImagePLUS: TPicture read FPicACTIVE write SetActivePic;
    property ImageDISABLED: TPicture read FPicDISABLED write SetDisabledPic;
    property SpacerPIXELS: Integer read FSpacer write SetSpacer;
    property DropDOWN_MENU : TPopUpMenu read _F_DropDOWN_MENU write SetDOWN_MENU;
    property _Color_Lite : TColor read F_LITE write _SetLiteColor;
    property _Color_Dark : TColor read F_DARK write _SetDarkColor;
    property _Group : Integer read FGroup write _SetGroup;
    property OnClick;
    property OnMouseLeave: TNotifyEvent read MLeave write MLeave;
    property OnMouseEnter: TNotifyEvent read MEnter write MEnter;
    
  end;

procedure Register;

implementation

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('Vcl++', [TxocCButton]);
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
constructor TxocCButton.Create(AOwner: TComponent);
begin

Inherited Create(AOwner);

F_TheOwner:=AOwner;

FPicACTIVE:=TPicture.Create;
FPicDISABLED:=TPicture.Create;

Height:=40;
Width:=120;
FTikSTEP:=0;
SpacerPIXELS:=4;
_F_MouseIsDOWN:=false;
_F_MouseIsENTER:=false;
_F_BtnSELECTED:=false;

FStyleDEFAULT:=sdFLAT;

FGroup:=0;

Cursor:=crHandPoint;
Caption:=Name;

_Color_Lite:=clYellow;
_Color_Dark:=clMaroon;

end;

//------------------------------------------------------------------------------
destructor TxocCButton.Destroy;
begin

FPicDISABLED.Free;
FPicACTIVE.Free;
  inherited Destroy;
end;

//------------------------------------------------------------------------------
procedure TxocCButton.Paint;
var
Color1, Color2: TColor;
Text: string;
Rekt,Reks: TRect;
FCV : TCanvas;

         procedure BevelRect(const R: TRect);
         begin
           with Canvas do
           begin
             Pen.Color := Color1;
             PolyLine([Point(R.Left, R.Bottom), Point(R.Left, R.Top), Point(R.Right, R.Top)]);
             Pen.Color := Color2;
             PolyLine([Point(R.Right, R.Top), Point(R.Right, R.Bottom), Point(R.Left, R.Bottom)]);
           end;
         end;

         procedure DoDrawTikPopUpMenu;
         begin

           if (_F_DropDOWN_MENU<>nil) then
           begin
           FCV:=TCanvas.Create;
           try
             FCV.Handle:=Canvas.Handle;
             FCV.Brush.Style:=bsClear;
             FCV.Font.Name:='webdings';
             FCV.Font.Color:=Font.Color;
             FCV.Font.Size:=9;
             FCV.TextRect(ClientRect,ClientRect.right-16 , ClientRect.Top+FTikSTEP, '6');
           finally FCV.Handle:=0; FCV.Free; end;
           end;

         end;

begin


if not Enabled then FTikSTEP:=0;

Rekt := ClientRect;
Reks := ClientRect;
OffsetRect(Rekt, 0,(Rekt.Top+(Height div 2))-6);

Inc(Rekt.Left,(FSpacer*3)+16);
Inc(Rekt.Left,FTikSTEP); // effects mouse
Inc(Rekt.Top,FTikSTEP); // effects mouse


Text := Caption;

  Canvas.Font := Font;
  Canvas.Brush.Style := bsClear;
  if (FGroup<>0)and(_F_BtnSELECTED) then
                     begin
                     Canvas.Brush.Color := $00EBEBEB;
                     Canvas.Font.Color := clHighlight;
                     Canvas.Font.Style:=[fsBold];
                     Canvas.FillRect(Reks);
                     end;


  if Enabled then
  begin
  DrawText(Canvas.Handle, PChar(Text), Length(Text), Rekt, 0);
  if (FPicACTIVE.Graphic<>nil) then Canvas.draw(FSpacer+FTikSTEP,FSpacer+FTikSTEP, FPicACTIVE.Graphic);
  end
  else
  begin

    OffsetRect(Rekt, 1, 1);
    Canvas.Font.Color := F_LITE;
    DrawText(Canvas.Handle, PChar(Text), Length(Text), Rekt, 0);

    OffsetRect(Rekt, -1, -1);
    Canvas.Font.Color := F_DARK;
    DrawText(Canvas.Handle, PChar(Text), Length(Text), Rekt, 0);

  if (FPicDISABLED.Graphic<>nil) then Canvas.draw(FSpacer+FTikSTEP,FSpacer+FTikSTEP, FPicDISABLED.Graphic);
  end;








  with Canvas do
  begin

  Pen.Width := 1;



    Case FBStyle Of

      bsDefault : begin

                      Case FStyleDEFAULT of

                          sdFLAT : if (csDesigning in ComponentState) then
                                   begin
                                   Color1 := F_DARK;
                                   Color2 := F_DARK;
                                   end else begin DoDrawTikPopUpMenu; exit; end; //

                        sdFRAMED : begin
                                   Color1 := F_DARK;
                                   Color2 := F_DARK;
                                   end;

                        sdRAISED : begin
                                   Color1 := F_LITE;
                                   Color2 := F_DARK;
                                   end;
                      end;
                  //Color1 := clBtnShadow;
                  //Color2 := clBtnShadow;  STOP lite/dark STOP styling colors!!! avance !!
                  end;

      bsLowered : begin
                  Color1 := F_DARK;
                  Color2 := F_LITE;
                  end;

       bsRaised : begin
                  Color1 := F_LITE;
                  Color2 := F_DARK;
                  if _F_MouseIsDOWN then begin _SetFrameStyle(bsLowered); exit; end;
                  end;
    end;



  if Enabled then BevelRect(Rect(0, 0, Width - 1, Height - 1));

  DoDrawTikPopUpMenu;


  end;




end;


//------------------------------------------------------------------------------
procedure TxocCButton._SetFrameStyle(val:TBBStyle);
begin
FBStyle:=val;
Invalidate;
end;


//------------------------------------------------------------------------------
procedure TxocCButton._SetDefaultStyle(val:TStyleDEF);
begin
FStyleDEFAULT:=val;
Invalidate;
end;

//------------------------------------------------------------------------------
procedure TxocCButton.MouseLeave(var Message: TMessage);
begin

if (_F_BtnSELECTED)then exit;

FTikSTEP:=0;
_F_MouseIsENTER:=false;
_SetFrameStyle(bsDefault);


if Assigned (MLeave) then MLeave(Self);
end;

//------------------------------------------------------------------------------
procedure TxocCButton.MouseEnter(var Message: TMessage);
begin

if (_F_BtnSELECTED)then exit;

//FTikSTEP:=-1;
_F_MouseIsENTER:=true;
_SetFrameStyle(bsRaised);
if Assigned(MEnter) then MEnter(Self);
end;

//------------------------------------------------------------------------------
procedure TxocCButton.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
APoint:TPoint;
begin

if (_F_BtnSELECTED)then exit;

FTikSTEP:=1;
_F_MouseIsDOWN:=true;
_SetFrameStyle(bsLowered);

(* *)
APoint := ClientToScreen(Point(0, ClientHeight+1));
if (_F_DropDOWN_MENU<>nil) then
begin
_F_DropDOWN_MENU.Popup(APoint.X, APoint.Y);
_F_MouseIsDOWN:=false;
_SetFrameStyle(bsDefault);
end;


//if Assigned(MouseDown) then MouseDown(Self,Button, Shift, X, Y);

end;
//------------------------------------------------------------------------------
procedure TxocCButton.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
i:integer;
begin

FTikSTEP:=0;
_F_MouseIsDOWN:=false;

if _F_MouseIsENTER then begin
                        


                            if (FGroup<>0) then
                            begin
                            _F_BtnSELECTED:=true;

                            for i:=0 to F_TheOwner.ComponentCount-1 do
                            if (F_TheOwner.Components[i] is TxocCButton) then
                            if (TxocCButton(F_TheOwner.Components[i])._Group=FGroup) and
                            (TxocCButton(F_TheOwner.Components[i])<>Self) then
                            begin
                            TxocCButton(F_TheOwner.Components[i])._F_BtnSELECTED:=false;
                            TxocCButton(F_TheOwner.Components[i])._SetFrameStyle(bsDefault);
                            end;

                            _SetFrameStyle(bsLowered);
                            end
                            else
                            _SetFrameStyle(bsDefault);

                        
                        end
                        else begin
                             _F_BtnSELECTED:=false;
                             _SetFrameStyle(bsDefault);
                             end;
//_Style:=bsFramed;
end;


//------------------------------------------------------------------------------
procedure TxocCButton.SetActivePic(Value: TPicture);
begin

FPicACTIVE.Assign(Value);

//if (FPicACTIVE.Graphic<>nil) then begin
                            //Height:=FPicACTIVE.Graphic.Height+(FSpacer*2);
                            //FPicWidth:=FPic.Graphic.Width;
                            //end;


Invalidate;

end;

//------------------------------------------------------------------------------
procedure TxocCButton.SetDisabledPic(Value: TPicture);
begin

FPicDISABLED.Assign(Value);
Invalidate;

end;
//------------------------------------------------------------------------------
procedure TxocCButton.SetSpacer(Value: Integer);
begin

FSpacer:=Value;
Invalidate;
end;

//------------------------------------------------------------------------------
procedure TxocCButton.SetDOWN_MENU(val:TPopUpMenu);
begin

if _F_DropDOWN_MENU<>val then _F_DropDOWN_MENU:=val;

Invalidate;

end;
//------------------------------------------------------------------------------
procedure TxocCButton._SetLiteColor(val:TColor);
begin
F_LITE:=val;
Invalidate;
end;

//------------------------------------------------------------------------------
procedure TxocCButton._SetDarkColor(val:TColor);
begin
F_DARK:=val;
Invalidate;
end;

//------------------------------------------------------------------------------
procedure TxocCButton._SetGroup(val:Integer);
begin
FGroup:=val;
Invalidate;
end;

//------------------------------------------------------------------------------
procedure TxocCButton.CMTextChanged(var Message: TMessage);
begin
 Invalidate;
end;

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
procedure TxocCButton.CMFontChanged(var Message: TMessage);
begin
 Invalidate;
end;

//------------------------------------------------------------------------------
procedure TxocCButton.SetAsSELECTED;
begin
_F_MouseIsENTER:=true;
MouseUp(mbLeft,[],0,0);
if Assigned(OnClick) then OnClick(Self);
end;

end.
